import React from "react"
import Table, { Column, ColumnShape } from 'react-base-table'
import 'react-base-table/styles.css'

const BaseTable: React.FC = () => {

    let columns: ColumnShape<any>[] = [
        {
            key: 'name',
            title: 'Name',
            dataKey: 'name',
            width: 150,
            resizable: true,
            sortable: true,
            frozen: Column.FrozenDirection.LEFT,
        },
        {
            key: 'score',
            title: 'Score',
            dataKey: 'score.math',
            width: 60,
            align: Column.Alignment.CENTER,
            sortable: false,
        },
        {
            key: 'gender',
            title: '♂♀',
            dataKey: 'gender',
            width: 60,
            align: Column.Alignment.CENTER,
            sortable: true,
        },
        {
            key: 'birthday',
            title: 'Birthday',
            dataKey: 'birthday',
            width: 100,
            align: Column.Alignment.RIGHT,
            sortable: true,
        },
        {
            key: 'email',
            title: 'Email',
            dataKey: 'email',
            width: 200,
            resizable: true,
            sortable: true,
        },
        {
            key: 'country',
            title: 'Country',
            dataKey: 'country',
            width: 100,
            resizable: true,
            sortable: true,
        },
        {
            key: 'address',
            title: 'Address',
            dataKey: 'address.street',
            width: 200,
            resizable: true,
        },
        {
            key: 'name1',
            title: 'Name',
            dataKey: 'name',
            width: 150,
            resizable: true,
            sortable: true,
        },
        {
            key: 'name2',
            title: 'Name',
            dataKey: 'name',
            width: 150,
            resizable: true,
            sortable: true,
        },
        {
            key: 'name3',
            title: 'Name',
            dataKey: 'name',
            width: 150,
            resizable: true,
            sortable: true,
        },
        {
            key: 'name4',
            title: 'Name',
            dataKey: 'name',
            width: 150,
            resizable: true,
            sortable: true,
        },
        {
            key: 'name5',
            title: 'Name',
            dataKey: 'name',
            width: 150,
            resizable: true,
            sortable: true,
        },
        {
            key: 'name6',
            title: 'Name',
            dataKey: 'name',
            width: 150,
            resizable: true,
            sortable: true,
        },
        {
            title: '操作',
            key: 'action',
            width: 100,
            align: Column.Alignment.CENTER,
            frozen: Column.FrozenDirection.RIGHT,
            
            cellRenderer: ({ rowData }: any) => (
                <button
                    onClick={() => {

                    }}
                >
                    Remove
                </button>
            ),
        },
    ]

    const defaultData = Array.from({ length: 10000 }, (_, key) => ({
        id: key,
        name: 'row' + key,
        gender: '男',
        score: {
            math: 30,
        },
        birthday: 222,
        attachments: 111,
        description: '3333',
        email: '7787@qq.com',
        country: 'aaasdsad',
    }));

    return <Table fixed columns={columns} data={defaultData} width={600} height={400} />
}

export default React.memo(BaseTable)